#include <windows.h>

#include "spimain.h"
#include "hsp3spi.h"
#include "spiutil.h"
#include "hsp3win.h"
#include "../hsp3code.h"

VOID CALLBACK LoadTimerProc(HWND,UINT,UINT_PTR,DWORD);

int _infono = 0;
LPSTR _buf = NULL;
int _buflen = 0;
LPSTR _filename = NULL;
DWORD _dw = 0;
long _len = 0;
unsigned int _flag = 0;
PictureInfo *_lpInfo = NULL;
HANDLE *_pHBInfo = NULL;
HANDLE *_pHBm = NULL;
SPI_PROGRESS _lpPrgressCallback = NULL;
long _lData = 0;
HINSTANCE hInst;
HINSTANCE hDllInstGlobal;
BOOL loadsuc = FALSE;
UINT TimerID;
BOOL IsInitialized = FALSE;

bool WINAPI DllMain(
			HINSTANCE hInstDLL,
			DWORD fdwReason,
			LPVOID lpvReserved
){
	hInst = hInstDLL;
	hDllInstGlobal = hInst;
	if (fdwReason == DLL_PROCESS_DETACH)
	{
		if (loadsuc)
		{
			if (lbDllFree != NULL)
			{
				code_call(lbDllFree);
			}
			hsp3win_bye();
		}
	}
	if (fdwReason == DLL_PROCESS_ATTACH)
	{
//		TimerID = SetTimer(0,0,0,LoadTimerProc);//
	}
	return TRUE;
}

//VOID CALLBACK LoadTimerProc(HWND hwnd,UINT uMsg,UINT_PTR idEvent,DWORD dwTime)
BOOL LoadHSP()
{
//	KillTimer(0,TimerID);
#ifndef HSPDEBUG
	char Path[_MAX_PATH];
	char Drive[_MAX_DRIVE];
	char Dir[_MAX_DIR];
	char FileName[_MAX_FNAME];
	char axPath[_MAX_DRIVE + _MAX_DIR + _MAX_FNAME + 3];
	DWORD dwRet;
#endif
	int res;
	char *lpCmdParam = "obj";
	//
#ifdef HSPDEBUG
	res = hsp3spi_init( hInst, lpCmdParam );
#else
	dwRet = 0;
	dwRet = GetModuleFileNameA(hInst,Path,sizeof(Path));
	if (dwRet == 0)
	{
		return FALSE;
	}
	_splitpath(Path,Drive,Dir,FileName,NULL);
	wsprintfA(axPath,"%s%s%s%s",Drive,Dir,FileName,".ax");
	//
//	res = hsp3spi_init( hInst, axPath );
	res = hsp3spi_init(hInst,NULL);
#endif
	if (res)
	{
		return FALSE;//
	}
	loadsuc = TRUE;
	spi_init();
	return TRUE;
}

BOOL Initialize()
{
	BOOL bRet;
	if (IsInitialized == FALSE)
	{
		bRet = LoadHSP();
		if (bRet)
		{
			IsInitialized = TRUE;
			return TRUE;
		}else{
			return FALSE;
		}
	}
	return TRUE;
}

int _stdcall GetPluginInfo(int infono,LPSTR buf,int buflen)
{
	_infono = infono;
	_buf = buf;
	_buflen = buflen;
	if (IsInitialized == FALSE)
	{
		Initialize();
	}
	if ((lbGetPluginInfo != NULL) && (IsInitialized))
	{
		code_call(lbGetPluginInfo);
	}else{
		_infono = 0;
		_buf = NULL;
		_buflen = 0;
		return 0;
	}
	_infono = 0;
	_buf = NULL;
	_buflen = 0;
	return ctx->stat;
}

int _stdcall IsSupported(LPSTR filename,DWORD dw)
{
	LPSTR res;
	_filename = filename;
	_dw = dw;
	if (IsInitialized == FALSE)
	{
		Initialize();
	}
	if ((lbIsSupported != NULL) && (IsInitialized))
	{
		code_call(lbIsSupported);
	}else{
		_filename = NULL;
		_dw = 0;
		return 0;
	}
	_filename = NULL;
	_dw = 0;
	return ctx->stat;
}

int _stdcall GetPictureInfo(LPSTR buf,long len,unsigned int flag,PictureInfo *lpInfo)
{
	_buf = buf;
	_len = len;
	_flag = flag;
	_lpInfo = lpInfo;
	if (IsInitialized == FALSE)
	{
		Initialize();
	}
	if ((lbGetPictureInfo != NULL) && (IsInitialized))
	{
		code_call(lbGetPictureInfo);
	}else{
		_buf = NULL;
		_len = 0;
		_flag = 0;
		_lpInfo = NULL;
		return -1;
	}
	_buf = NULL;
	_len = 0;
	_flag = 0;
	_lpInfo = NULL;
	return ctx->stat;
}

int _stdcall GetPicture(LPSTR buf,long len,unsigned int flag,HANDLE *pHBInfo,HANDLE *pHBm,SPI_PROGRESS lpPrgressCallback,long lData)
{
	LPSTR res;
	_buf = buf;
	_len = len;
	_flag = flag;
	_pHBInfo = pHBInfo;
	_pHBm = pHBm;
	_lpPrgressCallback = lpPrgressCallback;
	_lData = lData;
	if (IsInitialized == FALSE)
	{
		Initialize();
	}
	if ((lbGetPicture != NULL) && (IsInitialized))
	{
		code_call(lbGetPicture);
	}else{	
		_buf = NULL;
		_len = 0;
		_flag = 0;
		_pHBInfo = NULL;
		_pHBm = NULL;
		_lpPrgressCallback = NULL;
		_lData = 0;
		return -1;
	}
	_buf = NULL;
	_len = 0;
	_flag = 0;
	_pHBInfo = NULL;
	_pHBm = NULL;
	_lpPrgressCallback = NULL;
	_lData = 0;
	return ctx->stat;
}

int _stdcall GetPreview(LPSTR buf,long len,unsigned int flag,HANDLE *pHBInfo,HANDLE *pHBm,SPI_PROGRESS lpPrgressCallback,long lData)
{
	_buf = buf;
	_len = len;
	_flag = flag;
	_pHBInfo = pHBInfo;
	_pHBm = pHBm;
	_lpPrgressCallback = lpPrgressCallback;
	_lData = lData;
	if (IsInitialized == FALSE)
	{
		Initialize();
	}
	if ((lbGetPreview != NULL) && (IsInitialized))
	{
		code_call(lbGetPreview);
	}else{	
		_buf = NULL;
		_len = 0;
		_flag = 0;
		_pHBInfo = NULL;
		_pHBm = NULL;
		_lpPrgressCallback = NULL;
		_lData = 0;
		return -1;
	}
	_buf = NULL;
	_len = 0;
	_flag = 0;
	_pHBInfo = NULL;
	_pHBm = NULL;
	_lpPrgressCallback = NULL;
	_lData = 0;
	return ctx->stat;
}